<html>
<head>
<title>OgreManualObject.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreManualObject.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreManualObject_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __OgreManualObject_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __OgreManualObject_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreResourceGroupManager_8h.html">OgreResourceGroupManager.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre
<a name="l00039"></a>00039 {
<a name="l00106"></a><a class="code" href="classOgre_1_1ManualObject.html">00106</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>
<a name="l00107"></a>00107     {
<a name="l00108"></a>00108     <span class="keyword">public</span>:
<a name="l00109"></a>00109         <a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00110"></a>00110         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112         <span class="comment">//pre-declare ManualObjectSection</span>
<a name="l00113"></a>00113         <span class="keyword">class </span><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html" title="Built, renderable section of geometry.">ManualObjectSection</a>;
<a name="l00114"></a>00114 
<a name="l00124"></a>00124         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00125"></a>00125         
<a name="l00133"></a>00133         <span class="keyword">virtual</span> <span class="keywordtype">void</span> estimateVertexCount(<span class="keywordtype">size_t</span> vcount);
<a name="l00134"></a>00134 
<a name="l00142"></a>00142         <span class="keyword">virtual</span> <span class="keywordtype">void</span> estimateIndexCount(<span class="keywordtype">size_t</span> icount);
<a name="l00143"></a>00143 
<a name="l00153"></a>00153         <span class="keyword">virtual</span> <span class="keywordtype">void</span> begin(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName,
<a name="l00154"></a>00154             <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> opType = <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10da8c00ee152b44fe8000c2fd675437c087" title="A list of triangles, 3 vertices per triangle.">RenderOperation::OT_TRIANGLE_LIST</a>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a62561ccf5ff323942a9a4fab94bee7e3" title="Default resource group name.">ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME</a>);
<a name="l00155"></a>00155 
<a name="l00159"></a><a class="code" href="classOgre_1_1ManualObject.html#a83143f157514a3bb44e325df19fdefde">00159</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ManualObject.html#a83143f157514a3bb44e325df19fdefde" title="Use before defining geometry to indicate that you intend to update the geometry regularly and want th...">setDynamic</a>(<span class="keywordtype">bool</span> dyn) { mDynamic = dyn; }
<a name="l00161"></a><a class="code" href="classOgre_1_1ManualObject.html#a1404661a0e201ad6171cd0d35c036297">00161</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a1404661a0e201ad6171cd0d35c036297" title="Gets whether this object is marked as dynamic.">getDynamic</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDynamic; }
<a name="l00162"></a>00162 
<a name="l00174"></a>00174         <span class="keyword">virtual</span> <span class="keywordtype">void</span> beginUpdate(<span class="keywordtype">size_t</span> sectionIndex);
<a name="l00182"></a>00182         <span class="keyword">virtual</span> <span class="keywordtype">void</span> position(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos);
<a name="l00184"></a>00184         <span class="keyword">virtual</span> <span class="keywordtype">void</span> position(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00185"></a>00185 
<a name="l00191"></a>00191         <span class="keyword">virtual</span> <span class="keywordtype">void</span> normal(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; norm);
<a name="l00193"></a>00193         <span class="keyword">virtual</span> <span class="keywordtype">void</span> normal(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00194"></a>00194 
<a name="l00202"></a>00202         <span class="keyword">virtual</span> <span class="keywordtype">void</span> tangent(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; tan);
<a name="l00204"></a>00204         <span class="keyword">virtual</span> <span class="keywordtype">void</span> tangent(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00205"></a>00205 
<a name="l00214"></a>00214         <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureCoord(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u);
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureCoord(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> v);
<a name="l00218"></a>00218         <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureCoord(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> v, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w);
<a name="l00220"></a>00220         <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureCoord(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w);
<a name="l00222"></a>00222         <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureCoord(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; uv);
<a name="l00224"></a>00224         <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureCoord(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; uvw);
<a name="l00226"></a>00226         <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureCoord(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; xyzw);
<a name="l00227"></a>00227 
<a name="l00230"></a>00230         <span class="keyword">virtual</span> <span class="keywordtype">void</span> colour(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; col);
<a name="l00234"></a>00234         <span class="keyword">virtual</span> <span class="keywordtype">void</span> colour(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> r, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> g, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> b, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> a = 1.0f);
<a name="l00235"></a>00235 
<a name="l00247"></a>00247         <span class="keyword">virtual</span> <span class="keywordtype">void</span> index(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> idx);
<a name="l00256"></a>00256         <span class="keyword">virtual</span> <span class="keywordtype">void</span> triangle(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i1, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i2, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i3);
<a name="l00265"></a>00265         <span class="keyword">virtual</span> <span class="keywordtype">void</span> quad(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i1, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i2, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i3, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i4);
<a name="l00266"></a>00266 
<a name="l00268"></a>00268         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getCurrentVertexCount() <span class="keyword">const</span>;
<a name="l00269"></a>00269 
<a name="l00271"></a>00271         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getCurrentIndexCount() <span class="keyword">const</span>;
<a name="l00272"></a>00272         
<a name="l00277"></a>00277         <span class="keyword">virtual</span> ManualObjectSection* end(<span class="keywordtype">void</span>);
<a name="l00278"></a>00278 
<a name="l00288"></a>00288         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMaterialName(<span class="keywordtype">size_t</span> subindex, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; group = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a62561ccf5ff323942a9a4fab94bee7e3" title="Default resource group name.">ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME</a>);
<a name="l00289"></a>00289 
<a name="l00301"></a>00301         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> convertToMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; meshName, 
<a name="l00302"></a>00302             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a62561ccf5ff323942a9a4fab94bee7e3" title="Default resource group name.">ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME</a>);
<a name="l00303"></a>00303 
<a name="l00313"></a>00313         <span class="keywordtype">void</span> setUseIdentityProjection(<span class="keywordtype">bool</span> useIdentityProjection);
<a name="l00314"></a>00314 
<a name="l00324"></a><a class="code" href="classOgre_1_1ManualObject.html#a54b0416a4bde818687699da8c73d51f1">00324</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a54b0416a4bde818687699da8c73d51f1" title="Returns whether or not to use an &#39;identity&#39; projection.">getUseIdentityProjection</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseIdentityProjection; }
<a name="l00325"></a>00325 
<a name="l00335"></a>00335         <span class="keywordtype">void</span> setUseIdentityView(<span class="keywordtype">bool</span> useIdentityView);
<a name="l00336"></a>00336 
<a name="l00346"></a><a class="code" href="classOgre_1_1ManualObject.html#a79071ea0007acab8f18cb4c6ffc6eaf9">00346</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a79071ea0007acab8f18cb4c6ffc6eaf9" title="Returns whether or not to use an &#39;identity&#39; view.">getUseIdentityView</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseIdentityView; }
<a name="l00347"></a>00347 
<a name="l00355"></a><a class="code" href="classOgre_1_1ManualObject.html#a44a840aa95ae13acb026db417b86b4f8">00355</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ManualObject.html#a44a840aa95ae13acb026db417b86b4f8" title="Sets the bounding box.">setBoundingBox</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box) { mAABB = box; }
<a name="l00356"></a>00356 
<a name="l00359"></a>00359         ManualObjectSection* getSection(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;
<a name="l00360"></a>00360 
<a name="l00363"></a>00363         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getNumSections(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00373"></a><a class="code" href="classOgre_1_1ManualObject.html#aaf0b959647ec405c9e2b95c86a674378">00373</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ManualObject.html#aaf0b959647ec405c9e2b95c86a674378" title="Sets whether or not to keep the original declaration order when queuing the renderables.">setKeepDeclarationOrder</a>(<span class="keywordtype">bool</span> keepOrder) { mKeepDeclarationOrder = keepOrder; }
<a name="l00374"></a>00374 
<a name="l00379"></a><a class="code" href="classOgre_1_1ManualObject.html#ad9b516742f7f117b8e8a2eec7187adc3">00379</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#ad9b516742f7f117b8e8a2eec7187adc3" title="Gets whether or not the declaration order is to be kept or not.">getKeepDeclarationOrder</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mKeepDeclarationOrder; }
<a name="l00380"></a>00380         <span class="comment">// MovableObject overrides</span>
<a name="l00381"></a>00381 
<a name="l00383"></a>00383         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00385"></a>00385         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00387"></a>00387         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00389"></a>00389         <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00391"></a>00391         <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* getEdgeList(<span class="keywordtype">void</span>);
<a name="l00393"></a>00393         <span class="keywordtype">bool</span> hasEdgeList(<span class="keywordtype">void</span>);
<a name="l00395"></a>00395         ShadowRenderableListIterator getShadowVolumeRenderableIterator(
<a name="l00396"></a>00396             <a class="code" href="group__General.html#ga79dcd426d291c31072c1ad6f183715d6" title="An enumeration of broad shadow techniques.">ShadowTechnique</a> shadowTechnique, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light, 
<a name="l00397"></a>00397             <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>* indexBuffer, 
<a name="l00398"></a>00398             <span class="keywordtype">bool</span> extrudeVertices, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrusionDist, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags = 0);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00402"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html">00402</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html" title="Built, renderable section of geometry.">ManualObjectSection</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">MovableAlloc</a>
<a name="l00403"></a>00403         {
<a name="l00404"></a>00404         <span class="keyword">protected</span>:
<a name="l00405"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#ac47b32174770f19f978d63e2f7f4f51d">00405</a>             <a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>* <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#ac47b32174770f19f978d63e2f7f4f51d">mParent</a>;
<a name="l00406"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#adf8ceebd421102d4a0e78f890269ee3c">00406</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#adf8ceebd421102d4a0e78f890269ee3c">mMaterialName</a>;
<a name="l00407"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a5d77eb9ce78b8d2bbbf7068d76397629">00407</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a5d77eb9ce78b8d2bbbf7068d76397629">mGroupName</a>;
<a name="l00408"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#af5842f2fba07bfb959d6bb59e33e190e">00408</a>             <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#af5842f2fba07bfb959d6bb59e33e190e">mMaterial</a>;
<a name="l00409"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#ab86dc067e8f5cad015ce15f86c21f23b">00409</a>             <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#ab86dc067e8f5cad015ce15f86c21f23b">mRenderOperation</a>;
<a name="l00410"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a27a047f4f85b869e8821df87b040371e">00410</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a27a047f4f85b869e8821df87b040371e">m32BitIndices</a>;
<a name="l00411"></a>00411 
<a name="l00412"></a>00412             
<a name="l00413"></a>00413         <span class="keyword">public</span>:
<a name="l00414"></a>00414             <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html" title="Built, renderable section of geometry.">ManualObjectSection</a>(<a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>* parent, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName,
<a name="l00415"></a>00415                 <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> opType, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a62561ccf5ff323942a9a4fab94bee7e3" title="Default resource group name.">ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME</a>);
<a name="l00416"></a>00416             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html" title="Built, renderable section of geometry.">ManualObjectSection</a>();
<a name="l00417"></a>00417             
<a name="l00419"></a>00419             <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>* getRenderOperation(<span class="keywordtype">void</span>);
<a name="l00421"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a2ebc2ef3461f121175e23618e60674ae">00421</a>             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a2ebc2ef3461f121175e23618e60674ae" title="Retrieve the material name in use.">getMaterialName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaterialName; }
<a name="l00423"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#abff439d12c46e64f1024ecae720172e8">00423</a>             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#abff439d12c46e64f1024ecae720172e8" title="Retrieve the material group in use.">getMaterialGroup</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGroupName; }
<a name="l00425"></a>00425             <span class="keywordtype">void</span> setMaterialName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a70da3137e703c147b98fbfbbebfbf023" title="Special resource group name which causes resource group to be automatically determined based on searc...">ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME</a> );
<a name="l00427"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a97bb4c6938ee4c94ad1ca17e8250151b">00427</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a97bb4c6938ee4c94ad1ca17e8250151b" title="Set whether we need 32-bit indices.">set32BitIndices</a>(<span class="keywordtype">bool</span> n32) { m32BitIndices = n32; }
<a name="l00429"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a2fe89e2534881b56c68c36d765d16402">00429</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html#a2fe89e2534881b56c68c36d765d16402" title="Get whether we need 32-bit indices.">get32BitIndices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m32BitIndices; }
<a name="l00430"></a>00430             
<a name="l00431"></a>00431             <span class="comment">// Renderable overrides</span>
<a name="l00433"></a>00433 <span class="comment"></span>            <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00435"></a>00435             <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00437"></a>00437             <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00439"></a>00439             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Ogre::Camera</a> *) <span class="keyword">const</span>;
<a name="l00441"></a>00441             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a> &amp;getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444                     
<a name="l00445"></a>00445         };
<a name="l00447"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html">00447</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html" title="Nested class to allow shadows.">ManualObjectSectionShadowRenderable</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>
<a name="l00448"></a>00448         {
<a name="l00449"></a>00449         <span class="keyword">protected</span>:
<a name="l00450"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#a206b30fb05c4dee1a1bb26c45f77eebb">00450</a>             <a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>* <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#a206b30fb05c4dee1a1bb26c45f77eebb">mParent</a>;
<a name="l00451"></a>00451             <span class="comment">// Shared link to position buffer</span>
<a name="l00452"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#a0d7e25bbc91959fcb06f4eed249c6394">00452</a>             <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#a0d7e25bbc91959fcb06f4eed249c6394">mPositionBuffer</a>;
<a name="l00453"></a>00453             <span class="comment">// Shared link to w-coord buffer (optional)</span>
<a name="l00454"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#acd26b9683f231a663241dd92fee73850">00454</a>             <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#acd26b9683f231a663241dd92fee73850">mWBuffer</a>;
<a name="l00455"></a>00455 
<a name="l00456"></a>00456         <span class="keyword">public</span>:
<a name="l00457"></a>00457             <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html" title="Nested class to allow shadows.">ManualObjectSectionShadowRenderable</a>(<a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>* parent, 
<a name="l00458"></a>00458                 <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>* indexBuffer, <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData, 
<a name="l00459"></a>00459                 <span class="keywordtype">bool</span> createSeparateLightCap, <span class="keywordtype">bool</span> isLightCap = <span class="keyword">false</span>);
<a name="l00460"></a>00460             ~<a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html" title="Nested class to allow shadows.">ManualObjectSectionShadowRenderable</a>();
<a name="l00462"></a>00462             <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00463"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#a751adfd961bebc9a3c5a40487c3ed581">00463</a>             <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#a751adfd961bebc9a3c5a40487c3ed581">getPositionBuffer</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mPositionBuffer; }
<a name="l00464"></a><a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#adf5e82c21a0ad6342823f22914b58346">00464</a>             <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSectionShadowRenderable.html#adf5e82c21a0ad6342823f22914b58346">getWBuffer</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mWBuffer; }
<a name="l00466"></a>00466             <span class="keyword">virtual</span> <span class="keywordtype">void</span> rebindIndexBuffer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>&amp; indexBuffer);
<a name="l00467"></a>00467 
<a name="l00468"></a>00468             
<a name="l00469"></a>00469 
<a name="l00470"></a>00470         };
<a name="l00471"></a>00471 
<a name="l00472"></a><a class="code" href="classOgre_1_1ManualObject.html#aed2302f68cdadd3f043d503eeeccd928">00472</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ManualObjectSection*&gt;::type</a> <a class="code" href="classOgre_1_1ManualObject.html#aed2302f68cdadd3f043d503eeeccd928">SectionList</a>;
<a name="l00473"></a>00473 
<a name="l00475"></a>00475         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00476"></a>00476             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00477"></a>00477         
<a name="l00478"></a>00478         
<a name="l00479"></a>00479     <span class="keyword">protected</span>:
<a name="l00481"></a><a class="code" href="classOgre_1_1ManualObject.html#aaeb850427ddb92ff6f1a6038affca9dc">00481</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#aaeb850427ddb92ff6f1a6038affca9dc" title="Dynamic?">mDynamic</a>;
<a name="l00483"></a><a class="code" href="classOgre_1_1ManualObject.html#ac98bc0badd4c29d636480f5c7db22fce">00483</a>         <a class="code" href="classOgre_1_1ManualObject.html#aed2302f68cdadd3f043d503eeeccd928">SectionList</a> <a class="code" href="classOgre_1_1ManualObject.html#ac98bc0badd4c29d636480f5c7db22fce" title="List of subsections.">mSectionList</a>;
<a name="l00485"></a><a class="code" href="classOgre_1_1ManualObject.html#a161f5fbfea25d580d4acd1ba9a78d6d9">00485</a>         <a class="code" href="classOgre_1_1ManualObject_1_1ManualObjectSection.html" title="Built, renderable section of geometry.">ManualObjectSection</a>* <a class="code" href="classOgre_1_1ManualObject.html#a161f5fbfea25d580d4acd1ba9a78d6d9" title="Current section.">mCurrentSection</a>;
<a name="l00487"></a><a class="code" href="classOgre_1_1ManualObject.html#a7883d6e9c4a5f5a9ebb5752842465840">00487</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a7883d6e9c4a5f5a9ebb5752842465840" title="Are we updating?">mCurrentUpdating</a>;
<a name="l00489"></a><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html">00489</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html" title="Temporary vertex structure.">TempVertex</a>
<a name="l00490"></a>00490         {
<a name="l00491"></a><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#a9d4515964a3051a0b7c6b60ca65bdfdf">00491</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#a9d4515964a3051a0b7c6b60ca65bdfdf">position</a>;
<a name="l00492"></a><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#a19411aec4007e5d720d761e46e283aac">00492</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#a19411aec4007e5d720d761e46e283aac">normal</a>;
<a name="l00493"></a><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#a34b3f2d430ad90396d90ea5e07941da7">00493</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#a34b3f2d430ad90396d90ea5e07941da7">tangent</a>;
<a name="l00494"></a><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#af7424a293d8b620f472d0d1815ff2318">00494</a>             <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> texCoord[<a class="code" href="OgreConfig_8h.html#a73f03c4000193e826a1489b02ea50309" title="If set to 1, Real is typedef&#39;ed to double.">OGRE_MAX_TEXTURE_COORD_SETS</a>];
<a name="l00495"></a><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#a94d44f08aacb74e2af201a8d1e5ac63a">00495</a>             <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> texCoordDims[<a class="code" href="OgreConfig_8h.html#a73f03c4000193e826a1489b02ea50309" title="If set to 1, Real is typedef&#39;ed to double.">OGRE_MAX_TEXTURE_COORD_SETS</a>];
<a name="l00496"></a><a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#abdce83ba13674eba53d9658cd15ba6e7">00496</a>             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html#abdce83ba13674eba53d9658cd15ba6e7">colour</a>;
<a name="l00497"></a>00497         };
<a name="l00499"></a><a class="code" href="classOgre_1_1ManualObject.html#aeca61a2894ae434a1ff85d97f318f0fa">00499</a>         <a class="code" href="structOgre_1_1ManualObject_1_1TempVertex.html" title="Temporary vertex structure.">TempVertex</a> <a class="code" href="classOgre_1_1ManualObject.html#aeca61a2894ae434a1ff85d97f318f0fa" title="Temp storage.">mTempVertex</a>;
<a name="l00501"></a><a class="code" href="classOgre_1_1ManualObject.html#adb93e53d87004ae1271425d719116811">00501</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#adb93e53d87004ae1271425d719116811" title="First vertex indicator.">mFirstVertex</a>;
<a name="l00503"></a><a class="code" href="classOgre_1_1ManualObject.html#a9f643530f9ca6214af5dc65362e08fe4">00503</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a9f643530f9ca6214af5dc65362e08fe4" title="Temp vertex data to copy?">mTempVertexPending</a>;
<a name="l00505"></a><a class="code" href="classOgre_1_1ManualObject.html#afed0847b57507dcd60dfd2888d6c3482">00505</a>         <span class="keywordtype">char</span>* <a class="code" href="classOgre_1_1ManualObject.html#afed0847b57507dcd60dfd2888d6c3482" title="System-memory buffer whilst we establish the size required.">mTempVertexBuffer</a>;
<a name="l00507"></a><a class="code" href="classOgre_1_1ManualObject.html#ae7e3786ca417989a17379eef35224420">00507</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ManualObject.html#ae7e3786ca417989a17379eef35224420" title="System memory allocation size, in bytes.">mTempVertexSize</a>;
<a name="l00509"></a><a class="code" href="classOgre_1_1ManualObject.html#a4859c769ce58df5042e02500fbca0942">00509</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>* <a class="code" href="classOgre_1_1ManualObject.html#a4859c769ce58df5042e02500fbca0942" title="System-memory buffer whilst we establish the size required.">mTempIndexBuffer</a>;
<a name="l00511"></a><a class="code" href="classOgre_1_1ManualObject.html#a8ca006e1134d20d7a79965d69083ec8f">00511</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ManualObject.html#a8ca006e1134d20d7a79965d69083ec8f" title="System memory allocation size, in bytes.">mTempIndexSize</a>;
<a name="l00513"></a><a class="code" href="classOgre_1_1ManualObject.html#ad4af114b948103ea10023ce204476d5e">00513</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ManualObject.html#ad4af114b948103ea10023ce204476d5e" title="Current declaration vertex size.">mDeclSize</a>;
<a name="l00515"></a><a class="code" href="classOgre_1_1ManualObject.html#af73abdeb7397e7cdd5ebb253c1c50610">00515</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ManualObject.html#af73abdeb7397e7cdd5ebb253c1c50610" title="Estimated vertex count.">mEstVertexCount</a>;
<a name="l00517"></a><a class="code" href="classOgre_1_1ManualObject.html#ae254564df656062eaa24dd86aea504d5">00517</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ManualObject.html#ae254564df656062eaa24dd86aea504d5" title="Estimated index count.">mEstIndexCount</a>;
<a name="l00519"></a><a class="code" href="classOgre_1_1ManualObject.html#a59dc1b5a0acc98bba351909a6ff62652">00519</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1ManualObject.html#a59dc1b5a0acc98bba351909a6ff62652" title="Current texture coordinate.">mTexCoordIndex</a>;
<a name="l00521"></a><a class="code" href="classOgre_1_1ManualObject.html#ae6f2dfc7296d474fea40ea6d87b4a19b">00521</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1ManualObject.html#ae6f2dfc7296d474fea40ea6d87b4a19b" title="Bounding box.">mAABB</a>;
<a name="l00523"></a><a class="code" href="classOgre_1_1ManualObject.html#ad628d6803704ede23d8854d804490281">00523</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1ManualObject.html#ad628d6803704ede23d8854d804490281" title="Bounding sphere.">mRadius</a>;
<a name="l00525"></a><a class="code" href="classOgre_1_1ManualObject.html#a0ecee00defc78c704ec7bc4ccf0c5203">00525</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a0ecee00defc78c704ec7bc4ccf0c5203" title="Any indexed geometry on any sections?">mAnyIndexed</a>;
<a name="l00527"></a><a class="code" href="classOgre_1_1ManualObject.html#ac1a333c9d4657e7124a6815101523872">00527</a>         <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* <a class="code" href="classOgre_1_1ManualObject.html#ac1a333c9d4657e7124a6815101523872" title="Edge list, used if stencil shadow casting is enabled.">mEdgeList</a>;
<a name="l00529"></a><a class="code" href="classOgre_1_1ManualObject.html#a81eb184c295eaa2021bb37fa647e4dd6">00529</a>         ShadowRenderableList <a class="code" href="classOgre_1_1ManualObject.html#a81eb184c295eaa2021bb37fa647e4dd6" title="List of shadow renderables.">mShadowRenderables</a>;
<a name="l00531"></a><a class="code" href="classOgre_1_1ManualObject.html#a224699b3081f88a9c8eda4467e4b2612">00531</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a224699b3081f88a9c8eda4467e4b2612" title="Whether to use identity projection for sections.">mUseIdentityProjection</a>;
<a name="l00533"></a><a class="code" href="classOgre_1_1ManualObject.html#a4b19580b985312a21211bf4eaefb8c36">00533</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#a4b19580b985312a21211bf4eaefb8c36" title="Whether to use identity view for sections.">mUseIdentityView</a>;
<a name="l00535"></a><a class="code" href="classOgre_1_1ManualObject.html#acac0f609b6b52a527debff1fb5368bfd">00535</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ManualObject.html#acac0f609b6b52a527debff1fb5368bfd" title="Keep declaration order or let the queue optimize it.">mKeepDeclarationOrder</a>;
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 
<a name="l00539"></a>00539         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetTempAreas(<span class="keywordtype">void</span>);
<a name="l00541"></a>00541         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resizeTempVertexBufferIfNeeded(<span class="keywordtype">size_t</span> numVerts);
<a name="l00543"></a>00543         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resizeTempIndexBufferIfNeeded(<span class="keywordtype">size_t</span> numInds);
<a name="l00544"></a>00544 
<a name="l00546"></a>00546         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyTempVertexToBuffer(<span class="keywordtype">void</span>);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548     };
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00552"></a><a class="code" href="classOgre_1_1ManualObjectFactory.html">00552</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ManualObjectFactory.html" title="Factory object for creating ManualObject instances.">ManualObjectFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>
<a name="l00553"></a>00553     {
<a name="l00554"></a>00554     <span class="keyword">protected</span>:
<a name="l00555"></a>00555         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* createInstanceImpl( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params);
<a name="l00556"></a>00556     <span class="keyword">public</span>:
<a name="l00557"></a><a class="code" href="classOgre_1_1ManualObjectFactory.html#ae7ff8d7532887e279d5bc70a022b94a8">00557</a>         <a class="code" href="classOgre_1_1ManualObjectFactory.html#ae7ff8d7532887e279d5bc70a022b94a8">ManualObjectFactory</a>() {}
<a name="l00558"></a><a class="code" href="classOgre_1_1ManualObjectFactory.html#aada4dab11e551ca13355df254ac0305b">00558</a>         <a class="code" href="classOgre_1_1ManualObjectFactory.html#aada4dab11e551ca13355df254ac0305b">~ManualObjectFactory</a>() {}
<a name="l00559"></a>00559 
<a name="l00560"></a><a class="code" href="classOgre_1_1ManualObjectFactory.html#a17fec4f461f88f160ddf4d049fb3b604">00560</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ManualObjectFactory.html#a17fec4f461f88f160ddf4d049fb3b604">FACTORY_TYPE_NAME</a>;
<a name="l00561"></a>00561 
<a name="l00562"></a>00562         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00563"></a>00563         <span class="keywordtype">void</span> destroyInstance( <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj);  
<a name="l00564"></a>00564 
<a name="l00565"></a>00565     };
<a name="l00568"></a>00568 }
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 <span class="preprocessor">#endif</span>
<a name="l00571"></a>00571 <span class="preprocessor"></span>
<a name="l00572"></a>00572 
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
